org.apache.hc.core5.http.nio.entity

## Class AbstractBinAsyncEntityProducer

- java.lang.Object
- - org.apache.hc.core5.http.nio.entity.AbstractBinAsyncEntityProducer

- All Implemented Interfaces:
    EntityDetails, AsyncDataProducer, AsyncEntityProducer, ResourceHolder

      @Contract(threading=SAFE_CONDITIONAL)
      public abstract class AbstractBinAsyncEntityProducer
      extends Object
      implements AsyncEntityProducer

  Abstract binary entity content producer.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractBinAsyncEntityProducer(int fragmentSizeHint, ContentType contentType)`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Returns the number of bytes immediately available for output.
    `protected abstract int` | `availableData()` Returns the number of bytes immediately available for output.
    `String` | `getContentEncoding()` Returns content encoding of the entity, if known.
    `long` | `getContentLength()` Returns length of the entity, if known.
    `String` | `getContentType()` Returns content type of the entity, if known.
    `Set<String>` | `getTrailerNames()` Preliminary declaration of trailing headers.
    `boolean` | `isChunked()` Returns chunked transfer hint for this entity.
    `void` | `produce(DataStreamChannel channel)` Triggered to signal the ability of the underlying data channel to accept more data.
    `protected abstract void` | `produceData(StreamChannel<ByteBuffer> channel)` Triggered to signal the ability of the underlying byte channel to accept more data.
    `void` | `releaseResources()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.hc.core5.http.nio.AsyncEntityProducer

      `failed, isRepeatable`

- - ### Constructor Detail

    - #### AbstractBinAsyncEntityProducer

          public AbstractBinAsyncEntityProducer(int fragmentSizeHint,
                                                ContentType contentType)

  - ### Method Detail

    - #### availableData

          protected abstract int availableData()

      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.
      Returns:
        the number of bytes immediately available for output

    - #### produceData

          protected abstract void produceData(StreamChannel<ByteBuffer> channel)
                                       throws IOException

      Triggered to signal the ability of the underlying byte channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.

      `StreamChannel` passed to this method is threading-safe.

      Parameters:
        `channel` - the data channel capable to accepting more data.
      Throws:
        `IOException`

    - #### getContentType

          public final String getContentType()

      Description copied from interface: `EntityDetails`
      Returns content type of the entity, if known.
      Specified by:
        `getContentType` in interface `EntityDetails`

    - #### getContentEncoding

          public String getContentEncoding()

      Description copied from interface: `EntityDetails`
      Returns content encoding of the entity, if known.
      Specified by:
        `getContentEncoding` in interface `EntityDetails`

    - #### isChunked

          public boolean isChunked()

      Description copied from interface: `EntityDetails`
      Returns chunked transfer hint for this entity.

      The behavior of wrapping entities is implementation dependent, but should respect the primary purpose.

      Specified by:
        `isChunked` in interface `EntityDetails`

    - #### getTrailerNames

          public Set<String> getTrailerNames()

      Description copied from interface: `EntityDetails`
      Preliminary declaration of trailing headers.
      Specified by:
        `getTrailerNames` in interface `EntityDetails`

    - #### getContentLength

          public long getContentLength()

      Description copied from interface: `EntityDetails`
      Returns length of the entity, if known.
      Specified by:
        `getContentLength` in interface `EntityDetails`

    - #### available

          public final int available()

      Description copied from interface: `AsyncDataProducer`
      Returns the number of bytes immediately available for output. This method can be used as a hint to control output events of the underlying I/O session.
      Specified by:
        `available` in interface `AsyncDataProducer`
      Returns:
        the number of bytes immediately available for output

    - #### produce

          public final void produce(DataStreamChannel channel)
                             throws IOException

      Description copied from interface: `AsyncDataProducer`
      Triggered to signal the ability of the underlying data channel to accept more data. The data producer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `produce` in interface `AsyncDataProducer`
      Parameters:
        `channel` - the data channel capable to accepting more data.
      Throws:
        `IOException`

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.